/*
    Functions for kernel mode file io in Windows.
    Copyright (C) 2009-2015 Bo Brantn.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef FILEIO_H
#define FILEIO_H

#if defined(__cplusplus)
extern "C" {
#endif

HANDLE dopen(PUNICODE_STRING dirName);
HANDLE fopen(char *fileName, HANDLE rootDir);
int fread(HANDLE fileHandle, void *buf, int len);
int fread_mn_mdl(PFILE_OBJECT fileObject, PLARGE_INTEGER offset, ULONG len, PMDL *mdl);
int fread_mn_mdl_complete(PFILE_OBJECT fileObject, PMDL mdl);
void fclose(HANDLE fileHandle);
int send_all(INT_PTR sock, const char *buf, int len, int flags);
int send_file(INT_PTR sock, char *header, HANDLE fileHandle);
NTSTATUS lock_mdl_chain(PMDL mdl);
VOID unlock_and_free_mdl_chain(PMDL mdl);
int send_file_mdl(INT_PTR sock, char *header, HANDLE fileHandle);
int send_file_mn_mdl(INT_PTR sock, char *header, HANDLE fileHandle);

#if defined(__cplusplus)
}
#endif

#endif /* FILEIO_H */
